package br.ufsc.das.demo;
import br.ufsc.das.*;
import br.ufsc.das.util.ReceivedMessage;
import br.ufsc.das.util.Configuration;
import java.util.Random;
import java.util.concurrent.Semaphore;
/*
 * Client.java
 *
 * Created on 2 de Fevereiro de 2006, 16:40
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author alchieri
 */
public class Client extends Connection {

    private final static int WARM_UP = 1000;

    private Semaphore sm = new Semaphore(1);
    private int received = 0;
    private long startTime, endTime;

    private static int id = 1;
    private static int size = 1024;
    private static int iterations = 100;
    
    /** Creates a new instance of Client */
    public Client() {
        super(new Configuration(id));
    }
    
    public void run(){
        int[] targets = new int[]{0};

        byte[] message = new byte[size];
        new Random().nextBytes(message);

        //warming up the JVM
        for(int i=0;i<WARM_UP;i++){
            try{
                this.sm.acquire();
            }catch(Exception e){
               e.printStackTrace();
            }
            send(targets,message);
        }

        startTime = System.nanoTime();
        for(int i=0;i<iterations;i++){
            try{
                this.sm.acquire();
            }catch(Exception e){
               e.printStackTrace();
            }
            send(targets,message);
        }
    }
    
    public void deliver(ReceivedMessage msg){
        received++;
        
        if(received == iterations + WARM_UP){
           endTime = System.nanoTime();
           //br.ufsc.das.util.Logger.println("Mean Latency: "+((endTime-startTime)/iterations));
           System.exit(0);
        }
        
        this.sm.release();
    }
    
    public static void main(String[] args){
        if(args.length > 0) {
            id = new Integer(args[0]);
        }

        if(args.length > 1) {
            iterations = new Integer(args[1]);
        }

        if(args.length > 2) {
            size = new Integer(args[2]);
        }

        new Client().run();
    }
    
}
