
/*
 * Channel.java
 *
 * Created on 24 de Maio de 2006, 16:32
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das.usage;

import br.ufsc.das.usage.nio.Acceptor;
import br.ufsc.das.usage.nio.PacketChannel;
import br.ufsc.das.usage.nio.ProtocolDecoderAuth;
import br.ufsc.das.usage.nio.SelectorThread;
import br.ufsc.das.usage.nio.ProtocolDecoder;
import br.ufsc.das.util.EventListener;
import br.ufsc.das.util.Configuration;
import java.io.IOException;
import java.nio.channels.SocketChannel;

/**
 * Previously known as ServerChannel
 *
 * @author edualchieri
 */
public class ConnectionListener {
    
    private SelectorThread st;
    private ProcessWriter clientSide;
    private EventListener listener;
    private Configuration conf;
    
    /** Creates a new instance of Channel */
    public ConnectionListener(int listenPort, EventListener l, SelectorThread st,
            ProcessWriter clientSide, Configuration conf) throws Exception{
        this.st = st;
        this.listener = l;
        this.clientSide = clientSide;
        this.conf = conf;
        Acceptor acceptor = new Acceptor(listenPort, st, this);
        acceptor.openServerSocket();
        System.out.println("Listening on port: " + listenPort);
    }
    
    
    public void socketConnected(Acceptor acceptor, SocketChannel sc) {
        try {
            sc.socket().setReceiveBufferSize(200*1024);
            sc.socket().setSendBufferSize(200*1024);
            if(conf.useAuthentication()){
                PacketChannel pc = new PacketChannel(sc,st,
                        new ProtocolDecoderAuth(),null);
                pc.setListener(new SendReceiveAuthPacket(pc,listener,clientSide,conf));
                pc.resumeReading();
            }else{
                PacketChannel pc = new PacketChannel(sc,st,
                        new ProtocolDecoder(),null);
                pc.setListener(new SendReceivePacket(pc,listener,clientSide,conf));
                pc.resumeReading();
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    public void socketError(Acceptor acceptor, Exception ex) {
        //br.ufsc.das.util.Logger.println("["+ acceptor + "] Error: " + ex.getMessage());
    }
    
}
