
package br.ufsc.das.usage.nio;

import java.io.IOException;
import java.nio.ByteBuffer;


public class ProtocolDecoderAuth extends ProtocolDecoder {
    
    public static final byte SATX = 0x06;
    public static final byte RATX = 0x08;
    
    private byte[] bufferAuth = null;
    private int posAuth = 0;
    private int tamAuth = 0;
    
    public ProtocolDecoderAuth(){
    }

/*
    @Override
    public ReceivedPacket decode(ByteBuffer socketBuffer) throws IOException {
        while (socketBuffer.hasRemaining()) {
            if(newPckg){
                ctr = socketBuffer.get();
                tam = socketBuffer.getInt();
                tamAuth = socketBuffer.getInt();
                buffer = new byte[tam];
                bufferAuth = new byte[tamAuth];
                pos = 0;
                posAuth = 0;
                newPckg = false;
            }
            
            if(pos < tam){
                buffer[pos] = socketBuffer.get();
                pos++;
            }else{
                bufferAuth[posAuth] = socketBuffer.get();
                posAuth++;
                if(posAuth >= tamAuth){
                    newPckg = true;
                    return new ReceivedPacket(ctr,buffer,bufferAuth);
                }
            }

        }
        return null;
    }
*/

    @Override
    public ReceivedPacket decode(ByteBuffer socketBuffer) throws IOException {
        if (newPckg) {
            ctr = socketBuffer.get();
            tam = socketBuffer.getInt();
            tamAuth = socketBuffer.getInt();
            buffer = new byte[tam];
            bufferAuth = new byte[tamAuth];
            pos = 0;
            posAuth = 0;
            newPckg = false;
        }

        if(pos < tam) {
            //read data bytes
            int numBytesToRead = Math.min((tam-pos), socketBuffer.remaining());
            socketBuffer.get(buffer,pos,numBytesToRead);
            pos += numBytesToRead;
        }

        if(pos >= tam){
            //read authentication data
            int numBytesToReadAuth = Math.min((tamAuth-posAuth), socketBuffer.remaining());
            socketBuffer.get(bufferAuth,posAuth,numBytesToReadAuth);
            posAuth += numBytesToReadAuth;
        }

        if (posAuth >= tamAuth) {
            newPckg = true;
            return new ReceivedPacket(ctr, buffer, bufferAuth);
        } else {
            return null;
        }
    }

}