package br.ufsc.das.util;

import br.ufsc.das.blocking.ClientConnection;
import br.ufsc.das.blocking.ConnectionManager;
import br.ufsc.das.blocking.ServerConnection;
import br.ufsc.das.usage.ProcessWriter;
import br.ufsc.das.usage.ConnectionListener;
import br.ufsc.das.usage.nio.SelectorThread;

/*
 * CommunicationSupport.java
 *
 * Created on 30 de Janeiro de 2006, 09:24
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author alchieri
 */
public class CommunicationSupport {
    
    private Writer writer;
    private SelectorThread st;
    private Configuration conf;
    
    private ConnectionManager manager;

    /**
     * Creates a new instance of CommunicationSupport
     */
    public CommunicationSupport(Configuration conf) {
        try{
            this.conf = conf;
            if(conf.useBlockingChannels()){
                manager = new ConnectionManager(conf);
                writer = new ClientConnection(manager,conf);
            }else{
                st = new SelectorThread();
                writer = new ProcessWriter(st,conf);
            }
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    public Writer getWriter(){
        return  writer;
    }
    
    public void  setListener(EventListener listener, int port) throws Exception{
        if(conf.useBlockingChannels()){
            manager.setListener(listener);

            if(port >= 0){
                new ServerConnection(conf,listener,manager).start();
            }
        }else{
            ((ProcessWriter)writer).setListener(listener);

            if(port >= 0){
                new ConnectionListener(port,listener,st,(ProcessWriter)writer,conf);
            }
        }
    }
}
